// Package api provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen/v2 version v2.0.0 DO NOT EDIT.
package api

import (
	"bytes"
	"compress/gzip"
	"context"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"io"
	"net/http"
	"net/url"
	"path"
	"strings"
	"time"

	"github.com/getkin/kin-openapi/openapi3"
	"github.com/go-chi/chi/v5"
	"github.com/oapi-codegen/runtime"
	strictnethttp "github.com/oapi-codegen/runtime/strictmiddleware/nethttp"
	openapi_types "github.com/oapi-codegen/runtime/types"
)

// Attribute merged value of an attribute, including all observations about it.
type Attribute struct {
	Observations []Observation `json:"observations"`
	Value        interface{}   `json:"value"`
}

// Error The error that occured while processing this request.
type Error struct {
	Message string `json:"message"`
}

// Observation Moment of registration of a specific observation of a vreemdeling.
type Observation struct {
	Attribute string    `json:"attribute"`
	CreatedAt time.Time `json:"createdAt"`

	// Id UUID of observation.
	Id            ObservationId `json:"id"`
	InvalidatedAt *time.Time    `json:"invalidatedAt,omitempty"`
	Source        string        `json:"source"`
	Value         interface{}   `json:"value"`
}

// Proces Proces with its attributes
type Proces struct {
	Attributes *map[string]Attribute `json:"attributes,omitempty"`
	CreatedAt  time.Time             `json:"createdAt"`
	DeletedAt  *time.Time            `json:"deletedAt,omitempty"`
	Id         openapi_types.UUID    `json:"id"`
	ProcesId   string                `json:"procesId"`
	Source     string                `json:"source"`
	Status     string                `json:"status"`
	Type       string                `json:"type"`
}

// VreemdelingWithObservations A known vreemdeling, with merged attributes and full list of relevant observations.
type VreemdelingWithObservations struct {
	// Id V-number of vreemdeling.
	Id                   VreemdelingId        `json:"id"`
	AdditionalProperties map[string]Attribute `json:"-"`
}

// ObservationId UUID of observation.
type ObservationId = openapi_types.UUID

// ProcesId UUID of proces.
type ProcesId = openapi_types.UUID

// VreemdelingId V-number of vreemdeling.
type VreemdelingId = string

// PathProcesId UUID of proces.
type PathProcesId = ProcesId

// PathVreemdelingId V-number of vreemdeling.
type PathVreemdelingId = VreemdelingId

// QueryAttributes defines model for queryAttributes.
type QueryAttributes = []string

// QueryAttributesOptional defines model for queryAttributesOptional.
type QueryAttributesOptional = []string

// QuerySources defines model for querySources.
type QuerySources = []string

// BadRequestErrorResponse defines model for BadRequestErrorResponse.
type BadRequestErrorResponse struct {
	Errors []Error `json:"errors"`
}

// GoneErrorResponse defines model for GoneErrorResponse.
type GoneErrorResponse struct {
	Errors []Error `json:"errors"`
}

// ProcesResponse defines model for ProcesResponse.
type ProcesResponse struct {
	// Data Proces with its attributes
	Data Proces `json:"data"`
}

// ProcessenResponse defines model for ProcessenResponse.
type ProcessenResponse struct {
	Data []Proces `json:"data"`
}

// VreemdelingWithObservationsResponse defines model for VreemdelingWithObservationsResponse.
type VreemdelingWithObservationsResponse struct {
	// Data A known vreemdeling, with merged attributes and full list of relevant observations.
	Data VreemdelingWithObservations `json:"data"`
}

// ReadProcesByIdParams defines parameters for ReadProcesById.
type ReadProcesByIdParams struct {
	// Attributes Comma-separated list of attributes to show.
	Attributes *QueryAttributesOptional `form:"attributes,omitempty" json:"attributes,omitempty"`

	// Sources Comma-separated list of SIGMA sources to query. Query all sources if not specified.
	Sources *QuerySources `form:"sources,omitempty" json:"sources,omitempty"`
}

// ReadVreemdelingByIdParams defines parameters for ReadVreemdelingById.
type ReadVreemdelingByIdParams struct {
	// Attributes Comma-separated list of attributes to show.
	Attributes QueryAttributes `form:"attributes" json:"attributes"`

	// Sources Comma-separated list of SIGMA sources to query. Query all sources if not specified.
	Sources *QuerySources `form:"sources,omitempty" json:"sources,omitempty"`
}

// ReadProcessenByVreemdelingIdParams defines parameters for ReadProcessenByVreemdelingId.
type ReadProcessenByVreemdelingIdParams struct {
	// Attributes Comma-separated list of attributes to show.
	Attributes *QueryAttributesOptional `form:"attributes,omitempty" json:"attributes,omitempty"`

	// Sources Comma-separated list of SIGMA sources to query. Query all sources if not specified.
	Sources *QuerySources `form:"sources,omitempty" json:"sources,omitempty"`
}

// Getter for additional properties for VreemdelingWithObservations. Returns the specified
// element and whether it was found
func (a VreemdelingWithObservations) Get(fieldName string) (value Attribute, found bool) {
	if a.AdditionalProperties != nil {
		value, found = a.AdditionalProperties[fieldName]
	}
	return
}

// Setter for additional properties for VreemdelingWithObservations
func (a *VreemdelingWithObservations) Set(fieldName string, value Attribute) {
	if a.AdditionalProperties == nil {
		a.AdditionalProperties = make(map[string]Attribute)
	}
	a.AdditionalProperties[fieldName] = value
}

// Override default JSON handling for VreemdelingWithObservations to handle AdditionalProperties
func (a *VreemdelingWithObservations) UnmarshalJSON(b []byte) error {
	object := make(map[string]json.RawMessage)
	err := json.Unmarshal(b, &object)
	if err != nil {
		return err
	}

	if raw, found := object["id"]; found {
		err = json.Unmarshal(raw, &a.Id)
		if err != nil {
			return fmt.Errorf("error reading 'id': %w", err)
		}
		delete(object, "id")
	}

	if len(object) != 0 {
		a.AdditionalProperties = make(map[string]Attribute)
		for fieldName, fieldBuf := range object {
			var fieldVal Attribute
			err := json.Unmarshal(fieldBuf, &fieldVal)
			if err != nil {
				return fmt.Errorf("error unmarshaling field %s: %w", fieldName, err)
			}
			a.AdditionalProperties[fieldName] = fieldVal
		}
	}
	return nil
}

// Override default JSON handling for VreemdelingWithObservations to handle AdditionalProperties
func (a VreemdelingWithObservations) MarshalJSON() ([]byte, error) {
	var err error
	object := make(map[string]json.RawMessage)

	object["id"], err = json.Marshal(a.Id)
	if err != nil {
		return nil, fmt.Errorf("error marshaling 'id': %w", err)
	}

	for fieldName, field := range a.AdditionalProperties {
		object[fieldName], err = json.Marshal(field)
		if err != nil {
			return nil, fmt.Errorf("error marshaling '%s': %w", fieldName, err)
		}
	}
	return json.Marshal(object)
}

// RequestEditorFn  is the function signature for the RequestEditor callback function
type RequestEditorFn func(ctx context.Context, req *http.Request) error

// Doer performs HTTP requests.
//
// The standard http.Client implements this interface.
type HttpRequestDoer interface {
	Do(req *http.Request) (*http.Response, error)
}

// Client which conforms to the OpenAPI3 specification for this service.
type Client struct {
	// The endpoint of the server conforming to this interface, with scheme,
	// https://api.deepmap.com for example. This can contain a path relative
	// to the server, such as https://api.deepmap.com/dev-test, and all the
	// paths in the swagger spec will be appended to the server.
	Server string

	// Doer for performing requests, typically a *http.Client with any
	// customized settings, such as certificate chains.
	Client HttpRequestDoer

	// A list of callbacks for modifying requests which are generated before sending over
	// the network.
	RequestEditors []RequestEditorFn
}

// ClientOption allows setting custom parameters during construction
type ClientOption func(*Client) error

// Creates a new Client, with reasonable defaults
func NewClient(server string, opts ...ClientOption) (*Client, error) {
	// create a client with sane default values
	client := Client{
		Server: server,
	}
	// mutate client and add all optional params
	for _, o := range opts {
		if err := o(&client); err != nil {
			return nil, err
		}
	}
	// ensure the server URL always has a trailing slash
	if !strings.HasSuffix(client.Server, "/") {
		client.Server += "/"
	}
	// create httpClient, if not already present
	if client.Client == nil {
		client.Client = &http.Client{}
	}
	return &client, nil
}

// WithHTTPClient allows overriding the default Doer, which is
// automatically created using http.Client. This is useful for tests.
func WithHTTPClient(doer HttpRequestDoer) ClientOption {
	return func(c *Client) error {
		c.Client = doer
		return nil
	}
}

// WithRequestEditorFn allows setting up a callback function, which will be
// called right before sending the request. This can be used to mutate the request.
func WithRequestEditorFn(fn RequestEditorFn) ClientOption {
	return func(c *Client) error {
		c.RequestEditors = append(c.RequestEditors, fn)
		return nil
	}
}

// The interface specification for the client above.
type ClientInterface interface {
	// ReadProcesById request
	ReadProcesById(ctx context.Context, procesId PathProcesId, params *ReadProcesByIdParams, reqEditors ...RequestEditorFn) (*http.Response, error)

	// ReadVreemdelingById request
	ReadVreemdelingById(ctx context.Context, vreemdelingId PathVreemdelingId, params *ReadVreemdelingByIdParams, reqEditors ...RequestEditorFn) (*http.Response, error)

	// ReadProcessenByVreemdelingId request
	ReadProcessenByVreemdelingId(ctx context.Context, vreemdelingId PathVreemdelingId, params *ReadProcessenByVreemdelingIdParams, reqEditors ...RequestEditorFn) (*http.Response, error)
}

func (c *Client) ReadProcesById(ctx context.Context, procesId PathProcesId, params *ReadProcesByIdParams, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewReadProcesByIdRequest(c.Server, procesId, params)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) ReadVreemdelingById(ctx context.Context, vreemdelingId PathVreemdelingId, params *ReadVreemdelingByIdParams, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewReadVreemdelingByIdRequest(c.Server, vreemdelingId, params)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) ReadProcessenByVreemdelingId(ctx context.Context, vreemdelingId PathVreemdelingId, params *ReadProcessenByVreemdelingIdParams, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewReadProcessenByVreemdelingIdRequest(c.Server, vreemdelingId, params)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

// NewReadProcesByIdRequest generates requests for ReadProcesById
func NewReadProcesByIdRequest(server string, procesId PathProcesId, params *ReadProcesByIdParams) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "procesId", runtime.ParamLocationPath, procesId)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/processen/%s", pathParam0)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	if params != nil {
		queryValues := queryURL.Query()

		if params.Attributes != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", false, "attributes", runtime.ParamLocationQuery, *params.Attributes); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.Sources != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", false, "sources", runtime.ParamLocationQuery, *params.Sources); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		queryURL.RawQuery = queryValues.Encode()
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

// NewReadVreemdelingByIdRequest generates requests for ReadVreemdelingById
func NewReadVreemdelingByIdRequest(server string, vreemdelingId PathVreemdelingId, params *ReadVreemdelingByIdParams) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "vreemdelingId", runtime.ParamLocationPath, vreemdelingId)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/vreemdelingen/%s", pathParam0)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	if params != nil {
		queryValues := queryURL.Query()

		if queryFrag, err := runtime.StyleParamWithLocation("form", false, "attributes", runtime.ParamLocationQuery, params.Attributes); err != nil {
			return nil, err
		} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
			return nil, err
		} else {
			for k, v := range parsed {
				for _, v2 := range v {
					queryValues.Add(k, v2)
				}
			}
		}

		if params.Sources != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", false, "sources", runtime.ParamLocationQuery, *params.Sources); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		queryURL.RawQuery = queryValues.Encode()
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

// NewReadProcessenByVreemdelingIdRequest generates requests for ReadProcessenByVreemdelingId
func NewReadProcessenByVreemdelingIdRequest(server string, vreemdelingId PathVreemdelingId, params *ReadProcessenByVreemdelingIdParams) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "vreemdelingId", runtime.ParamLocationPath, vreemdelingId)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/vreemdelingen/%s/processen", pathParam0)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	if params != nil {
		queryValues := queryURL.Query()

		if params.Attributes != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", false, "attributes", runtime.ParamLocationQuery, *params.Attributes); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.Sources != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", false, "sources", runtime.ParamLocationQuery, *params.Sources); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		queryURL.RawQuery = queryValues.Encode()
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

func (c *Client) applyEditors(ctx context.Context, req *http.Request, additionalEditors []RequestEditorFn) error {
	for _, r := range c.RequestEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	for _, r := range additionalEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	return nil
}

// ClientWithResponses builds on ClientInterface to offer response payloads
type ClientWithResponses struct {
	ClientInterface
}

// NewClientWithResponses creates a new ClientWithResponses, which wraps
// Client with return type handling
func NewClientWithResponses(server string, opts ...ClientOption) (*ClientWithResponses, error) {
	client, err := NewClient(server, opts...)
	if err != nil {
		return nil, err
	}
	return &ClientWithResponses{client}, nil
}

// WithBaseURL overrides the baseURL.
func WithBaseURL(baseURL string) ClientOption {
	return func(c *Client) error {
		newBaseURL, err := url.Parse(baseURL)
		if err != nil {
			return err
		}
		c.Server = newBaseURL.String()
		return nil
	}
}

// ClientWithResponsesInterface is the interface specification for the client with responses above.
type ClientWithResponsesInterface interface {
	// ReadProcesByIdWithResponse request
	ReadProcesByIdWithResponse(ctx context.Context, procesId PathProcesId, params *ReadProcesByIdParams, reqEditors ...RequestEditorFn) (*ReadProcesByIdResponse, error)

	// ReadVreemdelingByIdWithResponse request
	ReadVreemdelingByIdWithResponse(ctx context.Context, vreemdelingId PathVreemdelingId, params *ReadVreemdelingByIdParams, reqEditors ...RequestEditorFn) (*ReadVreemdelingByIdResponse, error)

	// ReadProcessenByVreemdelingIdWithResponse request
	ReadProcessenByVreemdelingIdWithResponse(ctx context.Context, vreemdelingId PathVreemdelingId, params *ReadProcessenByVreemdelingIdParams, reqEditors ...RequestEditorFn) (*ReadProcessenByVreemdelingIdResponse, error)
}

type ReadProcesByIdResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *ProcesResponse
	JSON400      *BadRequestErrorResponse
}

// Status returns HTTPResponse.Status
func (r ReadProcesByIdResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r ReadProcesByIdResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type ReadVreemdelingByIdResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *VreemdelingWithObservationsResponse
	JSON400      *BadRequestErrorResponse
	JSON410      *GoneErrorResponse
}

// Status returns HTTPResponse.Status
func (r ReadVreemdelingByIdResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r ReadVreemdelingByIdResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

type ReadProcessenByVreemdelingIdResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *ProcessenResponse
	JSON400      *BadRequestErrorResponse
}

// Status returns HTTPResponse.Status
func (r ReadProcessenByVreemdelingIdResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r ReadProcessenByVreemdelingIdResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

// ReadProcesByIdWithResponse request returning *ReadProcesByIdResponse
func (c *ClientWithResponses) ReadProcesByIdWithResponse(ctx context.Context, procesId PathProcesId, params *ReadProcesByIdParams, reqEditors ...RequestEditorFn) (*ReadProcesByIdResponse, error) {
	rsp, err := c.ReadProcesById(ctx, procesId, params, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseReadProcesByIdResponse(rsp)
}

// ReadVreemdelingByIdWithResponse request returning *ReadVreemdelingByIdResponse
func (c *ClientWithResponses) ReadVreemdelingByIdWithResponse(ctx context.Context, vreemdelingId PathVreemdelingId, params *ReadVreemdelingByIdParams, reqEditors ...RequestEditorFn) (*ReadVreemdelingByIdResponse, error) {
	rsp, err := c.ReadVreemdelingById(ctx, vreemdelingId, params, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseReadVreemdelingByIdResponse(rsp)
}

// ReadProcessenByVreemdelingIdWithResponse request returning *ReadProcessenByVreemdelingIdResponse
func (c *ClientWithResponses) ReadProcessenByVreemdelingIdWithResponse(ctx context.Context, vreemdelingId PathVreemdelingId, params *ReadProcessenByVreemdelingIdParams, reqEditors ...RequestEditorFn) (*ReadProcessenByVreemdelingIdResponse, error) {
	rsp, err := c.ReadProcessenByVreemdelingId(ctx, vreemdelingId, params, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseReadProcessenByVreemdelingIdResponse(rsp)
}

// ParseReadProcesByIdResponse parses an HTTP response from a ReadProcesByIdWithResponse call
func ParseReadProcesByIdResponse(rsp *http.Response) (*ReadProcesByIdResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &ReadProcesByIdResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest ProcesResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest BadRequestErrorResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON400 = &dest

	}

	return response, nil
}

// ParseReadVreemdelingByIdResponse parses an HTTP response from a ReadVreemdelingByIdWithResponse call
func ParseReadVreemdelingByIdResponse(rsp *http.Response) (*ReadVreemdelingByIdResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &ReadVreemdelingByIdResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest VreemdelingWithObservationsResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest BadRequestErrorResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON400 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 410:
		var dest GoneErrorResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON410 = &dest

	}

	return response, nil
}

// ParseReadProcessenByVreemdelingIdResponse parses an HTTP response from a ReadProcessenByVreemdelingIdWithResponse call
func ParseReadProcessenByVreemdelingIdResponse(rsp *http.Response) (*ReadProcessenByVreemdelingIdResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &ReadProcessenByVreemdelingIdResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest ProcessenResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest BadRequestErrorResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON400 = &dest

	}

	return response, nil
}

// ServerInterface represents all server handlers.
type ServerInterface interface {
	// Find proces by ID
	// (GET /processen/{procesId})
	ReadProcesById(w http.ResponseWriter, r *http.Request, procesId PathProcesId, params ReadProcesByIdParams)
	// Find observations about a vreemdeling by ID
	// (GET /vreemdelingen/{vreemdelingId})
	ReadVreemdelingById(w http.ResponseWriter, r *http.Request, vreemdelingId PathVreemdelingId, params ReadVreemdelingByIdParams)
	// Find processen about a vreemdling by ID
	// (GET /vreemdelingen/{vreemdelingId}/processen)
	ReadProcessenByVreemdelingId(w http.ResponseWriter, r *http.Request, vreemdelingId PathVreemdelingId, params ReadProcessenByVreemdelingIdParams)
}

// Unimplemented server implementation that returns http.StatusNotImplemented for each endpoint.

type Unimplemented struct{}

// Find proces by ID
// (GET /processen/{procesId})
func (_ Unimplemented) ReadProcesById(w http.ResponseWriter, r *http.Request, procesId PathProcesId, params ReadProcesByIdParams) {
	w.WriteHeader(http.StatusNotImplemented)
}

// Find observations about a vreemdeling by ID
// (GET /vreemdelingen/{vreemdelingId})
func (_ Unimplemented) ReadVreemdelingById(w http.ResponseWriter, r *http.Request, vreemdelingId PathVreemdelingId, params ReadVreemdelingByIdParams) {
	w.WriteHeader(http.StatusNotImplemented)
}

// Find processen about a vreemdling by ID
// (GET /vreemdelingen/{vreemdelingId}/processen)
func (_ Unimplemented) ReadProcessenByVreemdelingId(w http.ResponseWriter, r *http.Request, vreemdelingId PathVreemdelingId, params ReadProcessenByVreemdelingIdParams) {
	w.WriteHeader(http.StatusNotImplemented)
}

// ServerInterfaceWrapper converts contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler            ServerInterface
	HandlerMiddlewares []MiddlewareFunc
	ErrorHandlerFunc   func(w http.ResponseWriter, r *http.Request, err error)
}

type MiddlewareFunc func(http.Handler) http.Handler

// ReadProcesById operation middleware
func (siw *ServerInterfaceWrapper) ReadProcesById(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// ------------- Path parameter "procesId" -------------
	var procesId PathProcesId

	err = runtime.BindStyledParameterWithLocation("simple", false, "procesId", runtime.ParamLocationPath, chi.URLParam(r, "procesId"), &procesId)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "procesId", Err: err})
		return
	}

	// Parameter object where we will unmarshal all parameters from the context
	var params ReadProcesByIdParams

	// ------------- Optional query parameter "attributes" -------------

	err = runtime.BindQueryParameter("form", false, false, "attributes", r.URL.Query(), &params.Attributes)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "attributes", Err: err})
		return
	}

	// ------------- Optional query parameter "sources" -------------

	err = runtime.BindQueryParameter("form", false, false, "sources", r.URL.Query(), &params.Sources)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "sources", Err: err})
		return
	}

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.ReadProcesById(w, r, procesId, params)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// ReadVreemdelingById operation middleware
func (siw *ServerInterfaceWrapper) ReadVreemdelingById(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// ------------- Path parameter "vreemdelingId" -------------
	var vreemdelingId PathVreemdelingId

	err = runtime.BindStyledParameterWithLocation("simple", false, "vreemdelingId", runtime.ParamLocationPath, chi.URLParam(r, "vreemdelingId"), &vreemdelingId)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "vreemdelingId", Err: err})
		return
	}

	// Parameter object where we will unmarshal all parameters from the context
	var params ReadVreemdelingByIdParams

	// ------------- Required query parameter "attributes" -------------

	if paramValue := r.URL.Query().Get("attributes"); paramValue != "" {

	} else {
		siw.ErrorHandlerFunc(w, r, &RequiredParamError{ParamName: "attributes"})
		return
	}

	err = runtime.BindQueryParameter("form", false, true, "attributes", r.URL.Query(), &params.Attributes)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "attributes", Err: err})
		return
	}

	// ------------- Optional query parameter "sources" -------------

	err = runtime.BindQueryParameter("form", false, false, "sources", r.URL.Query(), &params.Sources)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "sources", Err: err})
		return
	}

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.ReadVreemdelingById(w, r, vreemdelingId, params)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

// ReadProcessenByVreemdelingId operation middleware
func (siw *ServerInterfaceWrapper) ReadProcessenByVreemdelingId(w http.ResponseWriter, r *http.Request) {
	ctx := r.Context()

	var err error

	// ------------- Path parameter "vreemdelingId" -------------
	var vreemdelingId PathVreemdelingId

	err = runtime.BindStyledParameterWithLocation("simple", false, "vreemdelingId", runtime.ParamLocationPath, chi.URLParam(r, "vreemdelingId"), &vreemdelingId)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "vreemdelingId", Err: err})
		return
	}

	// Parameter object where we will unmarshal all parameters from the context
	var params ReadProcessenByVreemdelingIdParams

	// ------------- Optional query parameter "attributes" -------------

	err = runtime.BindQueryParameter("form", false, false, "attributes", r.URL.Query(), &params.Attributes)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "attributes", Err: err})
		return
	}

	// ------------- Optional query parameter "sources" -------------

	err = runtime.BindQueryParameter("form", false, false, "sources", r.URL.Query(), &params.Sources)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "sources", Err: err})
		return
	}

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.ReadProcessenByVreemdelingId(w, r, vreemdelingId, params)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r.WithContext(ctx))
}

type UnescapedCookieParamError struct {
	ParamName string
	Err       error
}

func (e *UnescapedCookieParamError) Error() string {
	return fmt.Sprintf("error unescaping cookie parameter '%s'", e.ParamName)
}

func (e *UnescapedCookieParamError) Unwrap() error {
	return e.Err
}

type UnmarshalingParamError struct {
	ParamName string
	Err       error
}

func (e *UnmarshalingParamError) Error() string {
	return fmt.Sprintf("Error unmarshaling parameter %s as JSON: %s", e.ParamName, e.Err.Error())
}

func (e *UnmarshalingParamError) Unwrap() error {
	return e.Err
}

type RequiredParamError struct {
	ParamName string
}

func (e *RequiredParamError) Error() string {
	return fmt.Sprintf("Query argument %s is required, but not found", e.ParamName)
}

type RequiredHeaderError struct {
	ParamName string
	Err       error
}

func (e *RequiredHeaderError) Error() string {
	return fmt.Sprintf("Header parameter %s is required, but not found", e.ParamName)
}

func (e *RequiredHeaderError) Unwrap() error {
	return e.Err
}

type InvalidParamFormatError struct {
	ParamName string
	Err       error
}

func (e *InvalidParamFormatError) Error() string {
	return fmt.Sprintf("Invalid format for parameter %s: %s", e.ParamName, e.Err.Error())
}

func (e *InvalidParamFormatError) Unwrap() error {
	return e.Err
}

type TooManyValuesForParamError struct {
	ParamName string
	Count     int
}

func (e *TooManyValuesForParamError) Error() string {
	return fmt.Sprintf("Expected one value for %s, got %d", e.ParamName, e.Count)
}

// Handler creates http.Handler with routing matching OpenAPI spec.
func Handler(si ServerInterface) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{})
}

type ChiServerOptions struct {
	BaseURL          string
	BaseRouter       chi.Router
	Middlewares      []MiddlewareFunc
	ErrorHandlerFunc func(w http.ResponseWriter, r *http.Request, err error)
}

// HandlerFromMux creates http.Handler with routing matching OpenAPI spec based on the provided mux.
func HandlerFromMux(si ServerInterface, r chi.Router) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{
		BaseRouter: r,
	})
}

func HandlerFromMuxWithBaseURL(si ServerInterface, r chi.Router, baseURL string) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{
		BaseURL:    baseURL,
		BaseRouter: r,
	})
}

// HandlerWithOptions creates http.Handler with additional options
func HandlerWithOptions(si ServerInterface, options ChiServerOptions) http.Handler {
	r := options.BaseRouter

	if r == nil {
		r = chi.NewRouter()
	}
	if options.ErrorHandlerFunc == nil {
		options.ErrorHandlerFunc = func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusBadRequest)
		}
	}
	wrapper := ServerInterfaceWrapper{
		Handler:            si,
		HandlerMiddlewares: options.Middlewares,
		ErrorHandlerFunc:   options.ErrorHandlerFunc,
	}

	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/processen/{procesId}", wrapper.ReadProcesById)
	})
	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/vreemdelingen/{vreemdelingId}", wrapper.ReadVreemdelingById)
	})
	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/vreemdelingen/{vreemdelingId}/processen", wrapper.ReadProcessenByVreemdelingId)
	})

	return r
}

type BadRequestErrorResponseJSONResponse struct {
	Errors []Error `json:"errors"`
}

type GoneErrorResponseJSONResponse struct {
	Errors []Error `json:"errors"`
}

type ProcesResponseJSONResponse struct {
	// Data Proces with its attributes
	Data Proces `json:"data"`
}

type ProcessenResponseJSONResponse struct {
	Data []Proces `json:"data"`
}

type VreemdelingWithObservationsResponseJSONResponse struct {
	// Data A known vreemdeling, with merged attributes and full list of relevant observations.
	Data VreemdelingWithObservations `json:"data"`
}

type ReadProcesByIdRequestObject struct {
	ProcesId PathProcesId `json:"procesId"`
	Params   ReadProcesByIdParams
}

type ReadProcesByIdResponseObject interface {
	VisitReadProcesByIdResponse(w http.ResponseWriter) error
}

type ReadProcesById200JSONResponse struct{ ProcesResponseJSONResponse }

func (response ReadProcesById200JSONResponse) VisitReadProcesByIdResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response)
}

type ReadProcesById400JSONResponse struct {
	BadRequestErrorResponseJSONResponse
}

func (response ReadProcesById400JSONResponse) VisitReadProcesByIdResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

type ReadVreemdelingByIdRequestObject struct {
	VreemdelingId PathVreemdelingId `json:"vreemdelingId"`
	Params        ReadVreemdelingByIdParams
}

type ReadVreemdelingByIdResponseObject interface {
	VisitReadVreemdelingByIdResponse(w http.ResponseWriter) error
}

type ReadVreemdelingById200JSONResponse struct {
	VreemdelingWithObservationsResponseJSONResponse
}

func (response ReadVreemdelingById200JSONResponse) VisitReadVreemdelingByIdResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response)
}

type ReadVreemdelingById400JSONResponse struct {
	BadRequestErrorResponseJSONResponse
}

func (response ReadVreemdelingById400JSONResponse) VisitReadVreemdelingByIdResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

type ReadVreemdelingById410JSONResponse struct{ GoneErrorResponseJSONResponse }

func (response ReadVreemdelingById410JSONResponse) VisitReadVreemdelingByIdResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(410)

	return json.NewEncoder(w).Encode(response)
}

type ReadProcessenByVreemdelingIdRequestObject struct {
	VreemdelingId PathVreemdelingId `json:"vreemdelingId"`
	Params        ReadProcessenByVreemdelingIdParams
}

type ReadProcessenByVreemdelingIdResponseObject interface {
	VisitReadProcessenByVreemdelingIdResponse(w http.ResponseWriter) error
}

type ReadProcessenByVreemdelingId200JSONResponse struct{ ProcessenResponseJSONResponse }

func (response ReadProcessenByVreemdelingId200JSONResponse) VisitReadProcessenByVreemdelingIdResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response)
}

type ReadProcessenByVreemdelingId400JSONResponse struct {
	BadRequestErrorResponseJSONResponse
}

func (response ReadProcessenByVreemdelingId400JSONResponse) VisitReadProcessenByVreemdelingIdResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

// StrictServerInterface represents all server handlers.
type StrictServerInterface interface {
	// Find proces by ID
	// (GET /processen/{procesId})
	ReadProcesById(ctx context.Context, request ReadProcesByIdRequestObject) (ReadProcesByIdResponseObject, error)
	// Find observations about a vreemdeling by ID
	// (GET /vreemdelingen/{vreemdelingId})
	ReadVreemdelingById(ctx context.Context, request ReadVreemdelingByIdRequestObject) (ReadVreemdelingByIdResponseObject, error)
	// Find processen about a vreemdling by ID
	// (GET /vreemdelingen/{vreemdelingId}/processen)
	ReadProcessenByVreemdelingId(ctx context.Context, request ReadProcessenByVreemdelingIdRequestObject) (ReadProcessenByVreemdelingIdResponseObject, error)
}

type StrictHandlerFunc = strictnethttp.StrictHttpHandlerFunc
type StrictMiddlewareFunc = strictnethttp.StrictHttpMiddlewareFunc

type StrictHTTPServerOptions struct {
	RequestErrorHandlerFunc  func(w http.ResponseWriter, r *http.Request, err error)
	ResponseErrorHandlerFunc func(w http.ResponseWriter, r *http.Request, err error)
}

func NewStrictHandler(ssi StrictServerInterface, middlewares []StrictMiddlewareFunc) ServerInterface {
	return &strictHandler{ssi: ssi, middlewares: middlewares, options: StrictHTTPServerOptions{
		RequestErrorHandlerFunc: func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusBadRequest)
		},
		ResponseErrorHandlerFunc: func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusInternalServerError)
		},
	}}
}

func NewStrictHandlerWithOptions(ssi StrictServerInterface, middlewares []StrictMiddlewareFunc, options StrictHTTPServerOptions) ServerInterface {
	return &strictHandler{ssi: ssi, middlewares: middlewares, options: options}
}

type strictHandler struct {
	ssi         StrictServerInterface
	middlewares []StrictMiddlewareFunc
	options     StrictHTTPServerOptions
}

// ReadProcesById operation middleware
func (sh *strictHandler) ReadProcesById(w http.ResponseWriter, r *http.Request, procesId PathProcesId, params ReadProcesByIdParams) {
	var request ReadProcesByIdRequestObject

	request.ProcesId = procesId
	request.Params = params

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.ReadProcesById(ctx, request.(ReadProcesByIdRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "ReadProcesById")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(ReadProcesByIdResponseObject); ok {
		if err := validResponse.VisitReadProcesByIdResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// ReadVreemdelingById operation middleware
func (sh *strictHandler) ReadVreemdelingById(w http.ResponseWriter, r *http.Request, vreemdelingId PathVreemdelingId, params ReadVreemdelingByIdParams) {
	var request ReadVreemdelingByIdRequestObject

	request.VreemdelingId = vreemdelingId
	request.Params = params

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.ReadVreemdelingById(ctx, request.(ReadVreemdelingByIdRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "ReadVreemdelingById")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(ReadVreemdelingByIdResponseObject); ok {
		if err := validResponse.VisitReadVreemdelingByIdResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// ReadProcessenByVreemdelingId operation middleware
func (sh *strictHandler) ReadProcessenByVreemdelingId(w http.ResponseWriter, r *http.Request, vreemdelingId PathVreemdelingId, params ReadProcessenByVreemdelingIdParams) {
	var request ReadProcessenByVreemdelingIdRequestObject

	request.VreemdelingId = vreemdelingId
	request.Params = params

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.ReadProcessenByVreemdelingId(ctx, request.(ReadProcessenByVreemdelingIdRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "ReadProcessenByVreemdelingId")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(ReadProcessenByVreemdelingIdResponseObject); ok {
		if err := validResponse.VisitReadProcessenByVreemdelingIdResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+xa63PbuBH/VzBoPty1JEUpfiT8VKfJZdxJ5tK8OlPb7UDkUsQZBBgAlKp69L93AJIS",
	"+NDLcXKem+TD+Sjitbu//e0ulnc4FnkhOHCtcHSHCyJJDhpk/aSzd1LEoC4T85yAiiUtNBUcR/jyJRIp",
	"Kux7pAWSoEvJA+xh+C/JCwY4wmEIZ0DSUx9Ozp/7J2eTxH8GycQ/OQvj9Cwh4/A8xR6mZj2zG/YwJ7mZ",
	"WTT7eljCl5JKSHCkZQkeVnEGOTEHeiIhxRH+02gjxah6q0brBVYrz679WQLkCTDKZ9vFmW8GbZNpPHl6",
	"cnp2/ux5OHzyeWuf+x6/vYqR4UsJcnmhtaTTUoPqS/A3kefEV2CMqCFBjCptZCLrOUYklYlFS6ArTBgl",
	"CntYFRLgVhMGHN+YEQUTCeAoJUxBLas9xUbYzdo7JXU262xCNeSqNaQ1wppOgzRb//uK+P+7+csT7GG9",
	"LOxILSmf4dX6ByIlWZpnpZd2rVTIHPeV96vVGWGPUImPTWkfRCnjY+D24fL12wukqmlGWXaZAP3D/EGE",
	"sfU7miIuNFIFxDSlkHQ0mtJYU0j9WBDsrZ8oTw7Va73PNqW66w8rtX2CnlJ/8qu/P//5HupdGX9RheCq",
	"Uu4LkryHLyUo/UpKId/X78yrWHANXJv/JUXBaEyMCUa/KWOHuyHh7jCYRRSOru5wDkqRWbWzQAvgGi2k",
	"MGe8MdQoRQFS0+oUzTRXUTtXcPS2i86sTH2lrFzSuGp2v1kPE9PfINZ4ZQZ26JrPCaMJorwoNVKl0YtB",
	"0MrDrwWHb6tDg9pUlDy5rwrdBX43Db7cHAP9NC010hkgKUoNiGoFLEVUIavln61eq1Tga5WaEG1/Iq1I",
	"5tJX5+WV89gjuliCIZ8LjSM8CSdP/fHEHz//OD6NwjAKw3+ZEJ0ck4hYefctWRFLjyDmhJWWWTgzTMbx",
	"jbHuwK+rBz/4Otvp5CdKE10qg4NiBkoTqTdMRfkUFsSwldLAmGWtHpobc+2CZgWMHhbt1EOQ+KaOHJUQ",
	"CvgGbQr4wwDu6gfiHifibrZCzqXPH7Z7lLY7MHY1BLEneH0dYTj13T+pzn6dKpBzyw8PF7Nsjh/dYeEs",
	"3sNcUwnURvsPaVnt6cfxeXR6Gp2MHatV//yB/9T/xntxhP8uMo4+cLHADo7cX+vd2hZve9J3l2vyEP5x",
	"r6C1Ay73B+aHMjaATEuGzHnscna1eldzqIuNSrslVQ5yBgmyMtqik2/qTg9RHrMyoXxmiyjXVIhMRakR",
	"1a0K6jhz1twyPvPDsR9OLLecROHpMdYMHwSlbVu2ZdgSFbaK81XgPFqcg8jQQdpQlViv7JahziYdYFaD",
	"vbaS+kD1cFU99AD3MQNkSwakM6KRiONSQoIWGWXQsKu9CsuoQrIqTzsY214bdi25HtkqsduTemV0R+Bm",
	"jSEZXcX2JH0rcrOLSJGEGVW68k3rZM0FROz6VPXGuYXriH1kkjHoTwfF6sPZsatv4hLNtpui3q2Fc3x3",
	"VkeSJutIhcxtHDBZkK9pDkNr0mSfUziav0zslHZu9WBHadS5/ZqnN6XvkZ3szAUoTbDnaN5bu2i9savg",
	"IRDXqVIPv9XvaEF1Zqpz1LozHMLlUKK8Mx78SJWPSpU7J0XVSY/NoLf6bPWUJLS6qH7XGrXLkzbpxWoA",
	"Xvu8ux0oD3OpBBg89JoVY7iNpINSyfXiZWkdsbdu4bSztrR03Gve0H9+czcOV08eiEoaeLhTBpDSvUN2",
	"hw+gaF/QtKpwGmp2tMNI9an2UdOujPkhwNomvAt0y8WCuyHYq+ivzpKdjgzhCUpLxtY9CAkM5sTEe+eQ",
	"3Qh+n2Lu4o9Zy108llKuy4f7M4d+o7QD/SEot9ONXrD99KnqBjvD7tXXPoqOho9Qjfg2u893d8Q/+7zM",
	"pyA7ffEd3fADqXNl87tUNNcxJK5CR04oM4GBzigj07/O+SzgrM8MH00xQhUiyKLMME7ddHwjbkGji3eX",
	"VTljjGfYwRAEqo+MUlvsALq2DUzB0WtpOyBv6czUBHALGjj6hQJLGJle4+CaX2okoZCgDPBMvZDbLmY5",
	"VWDZxvZNgDB/ISRL0DV2TnONkVoqDbmHSgUJmi7t8DmRVJQKFURqDlIhyu3vRC1ZmddTjKYZjaG+uaq7",
	"mq8+vXuDxoFxt1IafWVaFyoajaAsWADlaBxMRsBHNnxQba30S52k2CMZhwSpKmWGQRiE1iUK4KSgOMJP",
	"gzB4Wlkzs044Wt+zje4axK7MixnoPmze228mjJ6qsdiuLdfOht8DSap09sXSxiP3q5OrYW/fDBm1vkpZ",
	"eXvHb2v9Hzq1aYAbymp1bCdhuI2c1uNGnabZysMnh0zb1g22d0llnhO5tGblSfMFznSJLl8aXyMzo8aa",
	"WipOdUnSGLHl+PstaYDZD7rdArmO11qswW3dQHk2PJs1mujcurqynsqAJGamzoSCzSbVTZhlvz6EnHTk",
	"3jhqfxN0PJi+E4gOudr+amR5+GR8wPx+d30AkwOXk22sdNHqvGtfZx0C4A0/HUBK6w96GNv0Dw4Gc7CD",
	"zRTwF8vPna+/vj8mfxeCc/u034zjjKHaYDoASxseNMuajKA2xSZ4RqORyoiExGcmPvpTEt8CT/zx5NxE",
	"x2AccFoEVETPwmfhaB5azbZjr50YkKJQQZ2+BBz0QshbO/5mfbouMF/NQS51Zm/1rWipkEBnJicYEUaB",
	"Kw8Jia5xywOusUkYXpY6zoLBLw/tETsFldNMMHhXIge7sWcypMrlLMO7N6KFoFzb5ITmYDTtvCOxFtLZ",
	"XrQutocE1dlyI2hj00bA6nlYstqIq5vV/wMAAP//9smdRLIqAAA=",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %w", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	res := make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	resolvePath := PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		pathToFile := url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
